Index: Makefile
===================================================================
--- Makefile	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ Makefile	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -128,2 +128,7 @@
 ctags: 
 	ctags `find . -name "*.c"` `find . -name "*.h"`
+
+# Using this as a bogus Make target to test if a GNU-compatible version of
+# make is available.
+helloworld:
+	@echo Hello World
Index: bitlbee.c
===================================================================
--- bitlbee.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ bitlbee.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -36,4 +36,41 @@
 static gboolean bitlbee_io_new_client( gpointer data, gint fd, b_input_condition condition );
 
+static gboolean try_listen( struct addrinfo *res )
+{
+	int i;
+	
+	global.listen_socket = socket( res->ai_family, res->ai_socktype, res->ai_protocol );
+	if( global.listen_socket < 0 )
+	{
+		log_error( "socket" );
+		return FALSE;
+	}
+
+#ifdef IPV6_V6ONLY		
+	if( res->ai_family == AF_INET6 )
+	{
+		i = 0;
+		setsockopt( global.listen_socket, IPPROTO_IPV6, IPV6_V6ONLY,
+		            (char *) &i, sizeof( i ) );
+	}
+#endif
+
+	/* TIME_WAIT (?) sucks.. */
+	i = 1;
+	setsockopt( global.listen_socket, SOL_SOCKET, SO_REUSEADDR, &i, sizeof( i ) );
+
+	i = bind( global.listen_socket, res->ai_addr, res->ai_addrlen );
+	if( i == -1 )
+	{
+		closesocket( global.listen_socket );
+		global.listen_socket = -1;
+		
+		log_error( "bind" );
+		return FALSE;
+	}
+	
+	return TRUE;
+}
+
 int bitlbee_daemon_init()
 {
@@ -42,6 +79,6 @@
 	FILE *fp;
 	
-	log_link( LOGLVL_ERROR, LOGOUTPUT_SYSLOG );
-	log_link( LOGLVL_WARNING, LOGOUTPUT_SYSLOG );
+	log_link( LOGLVL_ERROR, LOGOUTPUT_CONSOLE );
+	log_link( LOGLVL_WARNING, LOGOUTPUT_CONSOLE );
 	
 	memset( &hints, 0, sizeof( hints ) );
@@ -63,25 +100,16 @@
 
 	global.listen_socket = -1;
-
+	
+	/* Try IPv6 first (which will become an IPv6+IPv4 socket). */
 	for( res = addrinfo_bind; res; res = res->ai_next )
-	{
-		global.listen_socket = socket( res->ai_family, res->ai_socktype, res->ai_protocol );
-		if( global.listen_socket < 0 )
-			continue;
-
-		/* TIME_WAIT (?) sucks.. */
-		i = 1;
-		setsockopt( global.listen_socket, SOL_SOCKET, SO_REUSEADDR, &i, sizeof( i ) );
-
-		i = bind( global.listen_socket, res->ai_addr, res->ai_addrlen );
-		if( i == -1 )
-		{
-			log_error( "bind" );
-			return( -1 );
-		}
-
-		break;
-	}
-
+		if( res->ai_family == AF_INET6 && try_listen( res ) )
+			break;
+	
+	/* The rest (so IPv4, I guess). */
+	if( res == NULL )
+		for( res = addrinfo_bind; res; res = res->ai_next )
+			if( res->ai_family != AF_INET6 && try_listen( res ) )
+				break;
+	
 	freeaddrinfo( addrinfo_bind );
 
@@ -107,4 +135,5 @@
 			exit( 0 );
 		
+		setsid();
 		chdir( "/" );
 		
@@ -137,4 +166,10 @@
 #endif
 	
+	if( !global.conf->nofork )
+	{
+		log_link( LOGLVL_ERROR, LOGOUTPUT_SYSLOG );
+		log_link( LOGLVL_WARNING, LOGOUTPUT_SYSLOG );
+	}
+	
 	return( 0 );
 }
Index: bitlbee.h
===================================================================
--- bitlbee.h	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ bitlbee.h	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -38,6 +38,8 @@
 
 #define PACKAGE "BitlBee"
-#define BITLBEE_VERSION "1.2.5"
+#define BITLBEE_VERSION "1.2.6"
 #define VERSION BITLBEE_VERSION
+#define BITLBEE_VER(a,b,c) (((a) << 16) + ((b) << 8) + (c))
+#define BITLBEE_VERSION_CODE BITLBEE_VER(1, 2, 6)
 
 #define MAX_STRING 511
@@ -168,4 +170,5 @@
 
 char *set_eval_root_nick( set_t *set, char *new_nick );
+char *set_eval_control_channel( set_t *set, char *new_name );
 
 extern global_t global;
Index: conf.c
===================================================================
--- conf.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ conf.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -80,5 +80,5 @@
 	}
 	
-	while( argc > 0 && ( opt = getopt( argc, argv, "i:p:P:nvIDFc:d:hR:u:" ) ) >= 0 )
+	while( argc > 0 && ( opt = getopt( argc, argv, "i:p:P:nvIDFc:d:hR:u:V" ) ) >= 0 )
 	/*     ^^^^ Just to make sure we skip this step from the REHASH handler. */
 	{
@@ -146,5 +146,12 @@
 			        "  -d  Specify alternative user configuration directory\n"
 			        "  -x  Command-line interface to password encryption/hashing\n"
-			        "  -h  Show this help page.\n" );
+			        "  -h  Show this help page.\n"
+			        "  -V  Show version info.\n" );
+			return NULL;
+		}
+		else if( opt == 'V' )
+		{
+			printf( "BitlBee %s\nAPI version %06x\n",
+			        BITLBEE_VERSION, BITLBEE_VERSION_CODE );
 			return NULL;
 		}
Index: debian/bitlbee.init
===================================================================
--- debian/bitlbee.init	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ debian/bitlbee.init	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -38,16 +38,8 @@
 d_start() {
 	# Make sure BitlBee can actually write its PID...
-	touch /var/run/bitlbee.pid
-	chown bitlbee: /var/run/bitlbee.pid
+	touch $PIDFILE
+	chown bitlbee: $PIDFILE
 	
-	# Clean up after the bug between 1.2-5 and 1.2.1-2 where BitlBee ran
-	# as root. (#494656 and #495877) Fixing this in the postinst script
-	# is not enough since the user will restart his BitlBee after up-
-	# grading the package, and the BitlBee running as root will then
-	# save its settings, re-setting ownership of the file to root.
-	# TODO: Remove this after a few revisions.
-	find /var/lib/bitlbee -uid 0 -name '*.xml' -exec chown bitlbee: {} \;
-
-	start-stop-daemon --start --quiet \
+	start-stop-daemon --start --quiet --pidfile $PIDFILE \
 		--exec $DAEMON -- -p $BITLBEE_PORT -P $PIDFILE $BITLBEE_OPTS
 }
Index: debian/changelog
===================================================================
--- debian/changelog	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ debian/changelog	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -1,2 +1,52 @@
+bitlbee (1.2.5-1) unstable; urgency=low
+
+  * New upstream version.
+  * Fixed issues with server-side MSN nickname corruption. (Closes: #538756)
+  * Debconf translation fixes/additions. (Closes: #541754, #563504)
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Wed, 17 Mar 2010 14:59:27 +0000
+
+bitlbee (1.2.4-2) unstable; urgency=low
+
+  * Merging in some changes from bzr-head:
+  * Use libresolv.so where possible. (Closes: #551775)
+  * Some include file changes that make the bitlbee-dev package useful again.
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Thu, 19 Nov 2009 23:02:43 +0000
+
+bitlbee (1.2.4-1) unstable; urgency=low
+
+  * New upstream version.
+  * Fixed issues with Yahoo! (Closes: #536178)
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Sat, 17 Oct 2009 18:12:45 +0100
+
+bitlbee (1.2.3-2) unstable; urgency=low
+
+  * Fixed bitblee typo in prerm (introduced by NMU 1.2.1-1.1).
+    (Closes: #531287)
+  * Fixed bitlbee.deb dep in bitlbee-dev to deal with binary NMUs.
+    (Closes: #531219)
+  * Fixed free port detection code in debian/config which was a bit limited
+    and also buggy.
+  * Removing code that edits bitlbee.conf from postinst (and chown code in
+    the init script), it's not really necessary anymore; bitlbee may only
+    still run as root if the admin doesn't read conffile diffs.
+    (Closes: #514572)
+  * No longer overwriting port number info in /etc/default/bitlbee with
+    what's in debconf. (Closes: #514148)
+  * Added notes about the above two changes to bitlbee.conf.
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Sun, 07 Jun 2009 21:17:39 +0100
+
+bitlbee (1.2.3-1) unstable; urgency=critical
+
+  * New upstream version.
+  * Fixes another account hijacking issue. (Closes: #498159)
+  * Restored --pidfile argument to start-stop-daemon, otherwise the init
+    script fails to restart BitlBee when users are connected.
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Sun, 07 Sep 2008 18:53:04 +0100
+
 bitlbee (1.2.2-1) unstable; urgency=critical
 
Index: debian/config
===================================================================
--- debian/config	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ debian/config	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -2,15 +2,21 @@
 
 . /usr/share/debconf/confmodule
+[ -f /etc/default/bitlbee ] && . /etc/default/bitlbee
 
 db_title BitlBee
 
-db_get bitlbee/serveport
-if [ "$RET" = "stillhavetoask" ]; then
-	if netstat -ltn | grep ':6667' 2> /dev/null > /dev/null; then
-		port=6668;
-	else
-		port=6667;
+if [ -n "$BITLBEE_PORT" ]; then
+	db_set bitlbee/serveport "$BITLBEE_PORT"
+else
+	db_get bitlbee/serveport
+	if [ "$RET" = "stillhavetoask" ]; then
+		listens=$(netstat -ltn | awk '{print $4}')
+		for port in 6667 6666 6668 6669; do
+			if [ $(expr "$listens " : ".*:$port\s") = "0" ]; then
+				break
+			fi
+		done
+		db_set bitlbee/serveport $port;
 	fi
-	db_set bitlbee/serveport $port;
 fi
 
Index: debian/control
===================================================================
--- debian/control	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ debian/control	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -19,5 +19,5 @@
 Package: bitlbee-dev
 Architecture: all
-Depends: bitlbee (= ${binary:Version})
+Depends: bitlbee (>= ${source:Version}), bitlbee (<< ${source:Version}.1~)
 Description: An IRC to other chat networks gateway
  This program can be used as an IRC server which forwards everything you
Index: debian/po/POTFILES.in
===================================================================
--- debian/po/POTFILES.in	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ debian/po/POTFILES.in	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -1,1 +1,1 @@
-[type: gettext/rfc822deb] bitlbee.templates.master
+[type: gettext/rfc822deb] templates
Index: debian/prerm
===================================================================
--- debian/prerm	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ debian/prerm	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -11,5 +11,5 @@
 else
 	if which invoke-rc.d >/dev/null 2>&1; then
-		invoke-rc.d bitblee stop || exit 0
+		invoke-rc.d bitlbee stop || exit 0
 	else
 		/etc/init.d/bitlbee stop || exit 0
Index: doc/CHANGES
===================================================================
--- doc/CHANGES	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ doc/CHANGES	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -3,4 +3,25 @@
 
 http://bugs.bitlbee.org/bitlbee/timeline?daysback=90&changeset=on
+
+Version 1.2.6:
+- Native (very basic) support for Twitter, implemented by Geert Mulders.
+  Currently supported are posting tweets, reading the ones of people you
+  follow, and sending (not yet receiving!) direct messages.
+- Fixed format of status messages in /WHOIS to improve IRC client
+  compatibility.
+- Show timestamps of offline messages/channel backlogs.
+- Allow saving MSN display names locally since sometimes this stuff breaks
+  server-side. (Use the local_display_name per-account setting.)
+- Suppress empty "Headline:" messages for certain new XMPP broadcast 
+  messages.
+- Better handling of XMPP contacts with multiple resources on-line. Default
+  behaviour now is to write to wherever the last message came from, or to
+  the bare JID (usually becomes a broadcast) if there wasn't any recent msg.
+- Added a switchboard_keepalives setting which should solve some issues with
+  talking to offline MSN contacts. (Although full support for offline
+  messages is not ready yet!)
+- The usual misc. bug fixes.
+
+Finished 19 Apr 2010
 
 Version 1.2.5:
@@ -23,5 +44,5 @@
   the main client).
 
-Fixed 17 Mar 2010
+Finished 17 Mar 2010
 
 Version 1.2.4:
Index: irc.c
===================================================================
--- irc.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ irc.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -55,4 +55,6 @@
 {
 	irc_t *irc = set->data;
+	char *test;
+	gsize test_bytes = 0;
 	GIConv ic, oc;
 
@@ -60,11 +62,25 @@
 		value = g_strdup( "utf-8" );
 
+	if( ( oc = g_iconv_open( value, "utf-8" ) ) == (GIConv) -1 )
+	{
+		return NULL;
+	}
+	
+	/* Do a test iconv to see if the user picked an IRC-compatible
+	   charset (for example utf-16 goes *horribly* wrong). */
+	if( ( test = g_convert_with_iconv( " ", 1, oc, NULL, &test_bytes, NULL ) ) == NULL ||
+	    test_bytes > 1 )
+	{
+		g_free( test );
+		g_iconv_close( oc );
+		irc_usermsg( irc, "Unsupported character set: The IRC protocol "
+		                  "only supports 8-bit character sets." );
+		return NULL;
+	}
+	g_free( test );
+	
 	if( ( ic = g_iconv_open( "utf-8", value ) ) == (GIConv) -1 )
 	{
-		return NULL;
-	}
-	if( ( oc = g_iconv_open( value, "utf-8" ) ) == (GIConv) -1 )
-	{
-		g_iconv_close( ic );
+		g_iconv_close( oc );
 		return NULL;
 	}
@@ -175,7 +191,9 @@
 	s = set_add( &irc->set, "charset", "utf-8", set_eval_charset, irc );
 	s = set_add( &irc->set, "color_encrypted", "true", set_eval_bool, irc );
+	s = set_add( &irc->set, "control_channel", irc->channel, set_eval_control_channel, irc );
 	s = set_add( &irc->set, "debug", "false", set_eval_bool, irc );
 	s = set_add( &irc->set, "default_target", "root", NULL, irc );
 	s = set_add( &irc->set, "display_namechanges", "false", set_eval_bool, irc );
+	s = set_add( &irc->set, "display_timestamps", "true", set_eval_bool, irc );
 	s = set_add( &irc->set, "handle_unknown", "root", NULL, irc );
 	s = set_add( &irc->set, "halfop_buddies", "encrypted", set_eval_halfop_buddies, irc );
@@ -192,4 +210,5 @@
 	s = set_add( &irc->set, "simulate_netsplit", "true", set_eval_bool, irc );
 	s = set_add( &irc->set, "strip_html", "true", NULL, irc );
+	s = set_add( &irc->set, "timezone", "local", set_eval_timezone, irc );
 	s = set_add( &irc->set, "to_char", ": ", set_eval_to_char, irc );
 	s = set_add( &irc->set, "typing_notice", "false", set_eval_bool, irc );
Index: irc_commands.c
===================================================================
--- irc_commands.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ irc_commands.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -498,5 +498,5 @@
 			irc_reply( irc, 301, "%s :%s", u->nick, u->away );
 		if( u->status_msg )
-			irc_reply( irc, 333, "%s :Status: %s", u->nick, u->status_msg );
+			irc_reply( irc, 320, "%s :%s", u->nick, u->status_msg );
 		
 		irc_reply( irc, 318, "%s :End of /WHOIS list", nick );
Index: lib/misc.c
===================================================================
--- lib/misc.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ lib/misc.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -77,4 +77,39 @@
 	
 	return mktime(&tm);
+}
+
+time_t mktime_utc( struct tm *tp )
+{
+	struct tm utc;
+	time_t res, tres;
+	
+	tp->tm_isdst = -1;
+	res = mktime( tp );
+	/* Problem is, mktime() just gave us the GMT timestamp for the
+	   given local time... While the given time WAS NOT local. So
+	   we should fix this now.
+	   
+	   Now I could choose between messing with environment variables
+	   (kludgy) or using timegm() (not portable)... Or doing the
+	   following, which I actually prefer...
+	   
+	   tzset() may also work but in other places I actually want to
+	   use local time.
+	   
+	   FFFFFFFFFFFFFFFFFFFFFUUUUUUUUUUUUUUUUUUUU!! */
+	gmtime_r( &res, &utc );
+	utc.tm_isdst = -1;
+	if( utc.tm_hour == tp->tm_hour && utc.tm_min == tp->tm_min )
+		/* Sweet! We're in UTC right now... */
+		return res;
+	
+	tres = mktime( &utc );
+	res += res - tres;
+	
+	/* Yes, this is a hack. And it will go wrong around DST changes.
+	   BUT this is more likely to be threadsafe than messing with
+	   environment variables, and possibly more portable... */
+	
+	return res;
 }
 
Index: lib/misc.h
===================================================================
--- lib/misc.h	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ lib/misc.h	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -43,4 +43,5 @@
 
 G_MODULE_EXPORT time_t get_time( int year, int month, int day, int hour, int min, int sec );
+G_MODULE_EXPORT time_t mktime_utc( struct tm *tp );
 double gettime( void );
 
Index: log.c
===================================================================
--- log.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ log.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -172,4 +172,6 @@
 		fprintf(stdout, "Debug: %s\n", message);
 #endif
+	/* Always log stuff in syslogs too. */
+	log_syslog(level, message);
 	return;
 }
Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ protocols/jabber/jabber.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -57,4 +57,6 @@
 	set_t *s;
 	char str[16];
+	
+	s = set_add( &acc->set, "activity_timeout", "600", set_eval_int, acc );
 	
 	g_snprintf( str, sizeof( str ), "%d", jabber_port_list[0] );
@@ -307,5 +309,5 @@
 		bud = jabber_buddy_by_ext_jid( ic, who, 0 );
 	else
-		bud = jabber_buddy_by_jid( ic, who, 0 );
+		bud = jabber_buddy_by_jid( ic, who, GET_BUDDY_BARE_OK );
 	
 	node = xt_new_node( "body", message, NULL );
@@ -352,15 +354,7 @@
 static void jabber_get_info( struct im_connection *ic, char *who )
 {
-	struct jabber_data *jd = ic->proto_data;
 	struct jabber_buddy *bud;
 	
-	if( strchr( who, '/' ) )
-		bud = jabber_buddy_by_jid( ic, who, 0 );
-	else
-	{
-		char *s = jabber_normalize( who );
-		bud = g_hash_table_lookup( jd->buddies, s );
-		g_free( s );
-	}
+	bud = jabber_buddy_by_jid( ic, who, GET_BUDDY_FIRST );
 	
 	while( bud )
Index: protocols/jabber/jabber.h
===================================================================
--- protocols/jabber/jabber.h	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ protocols/jabber/jabber.h	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -108,4 +108,11 @@
 };
 
+/* Somewhat messy data structure: We have a hash table with the bare JID as
+   the key and the head of a struct jabber_buddy list as the value. The head
+   is always a bare JID. If the JID has other resources (often the case,
+   except for some transports that don't support multiple resources), those
+   follow. In that case, the bare JID at the beginning doesn't actually
+   refer to a real session and should only be used for operations that
+   support incomplete JIDs. */
 struct jabber_buddy
 {
@@ -121,5 +128,5 @@
 	char *away_message;
 	
-	time_t last_act;
+	time_t last_msg;
 	jabber_buddy_flags_t flags;
 	
@@ -209,4 +216,6 @@
 	GET_BUDDY_EXACT = 2,	/* Get an exact match (only makes sense with bare JIDs). */
 	GET_BUDDY_FIRST = 4,	/* No selection, simply get the first resource for this JID. */
+	GET_BUDDY_BARE = 8,	/* Get the bare version of the JID (possibly inexistent). */
+	GET_BUDDY_BARE_OK = 16,	/* Allow returning a bare JID if that seems better. */
 } get_buddy_flags_t;
 
Index: protocols/jabber/jabber_util.c
===================================================================
--- protocols/jabber/jabber_util.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ protocols/jabber/jabber_util.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -4,5 +4,5 @@
 *  Jabber module - Misc. stuff                                              *
 *                                                                           *
-*  Copyright 2006 Wilmer van der Gaast <wilmer@gaast.net>                   *
+*  Copyright 2006-2010 Wilmer van der Gaast <wilmer@gaast.net>              
 *                                                                           *
 *  This program is free software; you can redistribute it and/or modify     *
@@ -345,4 +345,9 @@
 	if( ( bud = g_hash_table_lookup( jd->buddies, full_jid ) ) )
 	{
+		/* The first entry is always a bare JID. If there are more, we
+		   should ignore the first one here. */
+		if( bud->next )
+			bud = bud->next;
+		
 		/* If this is a transport buddy or whatever, it can't have more
 		   than one instance, so this is always wrong: */
@@ -379,8 +384,13 @@
 	else
 	{
-		/* Keep in mind that full_jid currently isn't really
-		   a full JID... */
-		new->bare_jid = g_strdup( full_jid );
+		new->full_jid = new->bare_jid = g_strdup( full_jid );
 		g_hash_table_insert( jd->buddies, new->bare_jid, new );
+		
+		if( s )
+		{
+			new->next = g_new0( struct jabber_buddy, 1 );
+			new->next->bare_jid = new->bare_jid;
+			new = new->next;
+		}
 	}
 	
@@ -408,5 +418,5 @@
 {
 	struct jabber_data *jd = ic->proto_data;
-	struct jabber_buddy *bud;
+	struct jabber_buddy *bud, *head;
 	char *s, *jid;
 	
@@ -420,4 +430,9 @@
 		if( ( bud = g_hash_table_lookup( jd->buddies, jid ) ) )
 		{
+			bare_exists = 1;
+			
+			if( bud->next )
+				bud = bud->next;
+			
 			/* Just return the first one for this bare JID. */
 			if( flags & GET_BUDDY_FIRST )
@@ -441,14 +456,7 @@
 					break;
 		}
-		else
-		{
-			/* This variable tells the if down here that the bare
-			   JID already exists and we should feel free to add
-			   more resources, if the caller asked for that. */
-			bare_exists = 1;
-		}
 		
 		if( bud == NULL && ( flags & GET_BUDDY_CREAT ) &&
-		    ( !bare_exists || imcb_find_buddy( ic, jid ) ) )
+		    ( bare_exists || imcb_find_buddy( ic, jid ) ) )
 		{
 			*s = '/';
@@ -464,5 +472,6 @@
 		char *set;
 		
-		bud = g_hash_table_lookup( jd->buddies, jid );
+		head = g_hash_table_lookup( jd->buddies, jid );
+		bud = ( head && head->next ) ? head->next : head;
 		
 		g_free( jid );
@@ -481,4 +490,6 @@
 			/* Looks like the caller doesn't care about details. */
 			return bud;
+		else if( flags & GET_BUDDY_BARE )
+			return head;
 		
 		best_prio = best_time = bud;
@@ -487,5 +498,5 @@
 			if( bud->priority > best_prio->priority )
 				best_prio = bud;
-			if( bud->last_act > best_time->last_act )
+			if( bud->last_msg > best_time->last_msg )
 				best_time = bud;
 		}
@@ -493,8 +504,15 @@
 		if( ( set = set_getstr( &ic->acc->set, "resource_select" ) ) == NULL )
 			return NULL;
-		else if( strcmp( set, "activity" ) == 0 )
+		else if( strcmp( set, "priority" ) == 0 )
+			return best_prio;
+		else if( flags & GET_BUDDY_BARE_OK ) /* && strcmp( set, "activity" ) == 0 */
+		{
+			if( best_time->last_msg + set_getint( &ic->acc->set, "activity_timeout" ) >= time( NULL ) )
+				return best_time;
+			else
+				return head;
+		}
+		else
 			return best_time;
-		else /* if( strcmp( set, "priority" ) == 0 ) */
-			return best_prio;
 	}
 }
@@ -538,5 +556,5 @@
 {
 	struct jabber_data *jd = ic->proto_data;
-	struct jabber_buddy *bud, *prev, *bi;
+	struct jabber_buddy *bud, *prev = NULL, *bi;
 	char *s, *full_jid;
 	
@@ -548,4 +566,7 @@
 	if( ( bud = g_hash_table_lookup( jd->buddies, full_jid ) ) )
 	{
+		if( bud->next )
+			bud = (prev=bud)->next;
+		
 		/* If there's only one item in the list (and if the resource
 		   matches), removing it is simple. (And the hash reference
@@ -555,14 +576,5 @@
 		      ( bud->resource && s && strcmp( bud->resource, s + 1 ) == 0 ) ) )
 		{
-			g_hash_table_remove( jd->buddies, bud->bare_jid );
-			g_free( bud->bare_jid );
-			g_free( bud->ext_jid );
-			g_free( bud->full_jid );
-			g_free( bud->away_message );
-			g_free( bud );
-			
-			g_free( full_jid );
-			
-			return 1;
+			return jabber_buddy_remove_bare( ic, full_jid );
 		}
 		else if( s == NULL || bud->resource == NULL )
@@ -575,5 +587,5 @@
 		else
 		{
-			for( bi = bud, prev = NULL; bi; bi = (prev=bi)->next )
+			for( bi = bud; bi; bi = (prev=bi)->next )
 				if( strcmp( bi->resource, s + 1 ) == 0 )
 					break;
@@ -586,6 +598,5 @@
 					prev->next = bi->next;
 				else
-					/* The hash table should point at the second
-					   item, because we're removing the first. */
+					/* Don't think this should ever happen anymore. */
 					g_hash_table_replace( jd->buddies, bi->bare_jid, bi->next );
 				
@@ -656,8 +667,7 @@
 time_t jabber_get_timestamp( struct xt_node *xt )
 {
-	struct tm tp, utc;
 	struct xt_node *c;
-	time_t res, tres;
 	char *s = NULL;
+	struct tm tp;
 	
 	for( c = xt->children; ( c = xt_find_node( c, "x" ) ); c = c->next )
@@ -677,28 +687,6 @@
 	tp.tm_year -= 1900;
 	tp.tm_mon --;
-	tp.tm_isdst = -1; /* GRRRRRRRRRRR */
-	
-	res = mktime( &tp );
-	/* Problem is, mktime() just gave us the GMT timestamp for the
-	   given local time... While the given time WAS NOT local. So
-	   we should fix this now.
-	
-	   Now I could choose between messing with environment variables
-	   (kludgy) or using timegm() (not portable)... Or doing the
-	   following, which I actually prefer... */
-	gmtime_r( &res, &utc );
-	utc.tm_isdst = -1; /* Once more: GRRRRRRRRRRRRRRRRRR!!! */
-	if( utc.tm_hour == tp.tm_hour && utc.tm_min == tp.tm_min )
-		/* Sweet! We're in UTC right now... */
-		return res;
-	
-	tres = mktime( &utc );
-	res += res - tres;
-	
-	/* Yes, this is a hack. And it will go wrong around DST changes.
-	   BUT this is more likely to be threadsafe than messing with
-	   environment variables, and possibly more portable... */
-	
-	return res;
+	
+	return mktime_utc( &tp );
 }
 
Index: protocols/jabber/message.c
===================================================================
--- protocols/jabber/message.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ protocols/jabber/message.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -71,5 +71,5 @@
 			if( bud )
 			{
-				bud->last_act = time( NULL );
+				bud->last_msg = time( NULL );
 				from = bud->ext_jid ? : bud->bare_jid;
 			}
@@ -80,6 +80,6 @@
 		if( type && strcmp( type, "headline" ) == 0 )
 		{
-			c = xt_find_node( node->children, "subject" );
-			g_string_append_printf( fullmsg, "Headline: %s\n", c && c->text_len > 0 ? c->text : "" );
+			if( ( c = xt_find_node( node->children, "subject" ) ) && c->text_len > 0 )
+				g_string_append_printf( fullmsg, "Headline: %s\n", c->text );
 			
 			/* <x xmlns="jabber:x:oob"><url>http://....</url></x> can contain a URL, it seems. */
Index: protocols/jabber/presence.c
===================================================================
--- protocols/jabber/presence.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ protocols/jabber/presence.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -68,7 +68,4 @@
 		{
 			bud->away_state = NULL;
-			/* Let's only set last_act if there's *no* away state,
-			   since it could be some auto-away thingy. */
-			bud->last_act = time( NULL );
 		}
 		
Index: protocols/msn/msn.c
===================================================================
--- protocols/msn/msn.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ protocols/msn/msn.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -31,14 +31,12 @@
 GSList *msn_switchboards;
 
-static char *msn_set_display_name( set_t *set, char *value );
+static char *set_eval_display_name( set_t *set, char *value );
 
 static void msn_init( account_t *acc )
 {
-	set_t *s;
-	
-	s = set_add( &acc->set, "display_name", NULL, msn_set_display_name, acc );
-	s->flags |= ACC_SET_NOSAVE | ACC_SET_ONLINE_ONLY;
-
-	s = set_add( &acc->set, "mail_notifications", "false", set_eval_bool, acc );
+	set_add( &acc->set, "display_name", NULL, set_eval_display_name, acc );
+	set_add( &acc->set, "local_display_name", "false", set_eval_bool, acc );
+	set_add( &acc->set, "mail_notifications", "false", set_eval_bool, acc );
+	set_add( &acc->set, "switchboard_keepalives", "false", set_eval_bool, acc );
 }
 
@@ -167,5 +165,5 @@
 static void msn_set_my_name( struct im_connection *ic, char *info )
 {
-	msn_set_display_name( set_find( &ic->acc->set, "display_name" ), info );
+	msn_set_display_name( ic, info );
 }
 
@@ -283,16 +281,12 @@
 }
 
-static char *msn_set_display_name( set_t *set, char *value )
+static char *set_eval_display_name( set_t *set, char *value )
 {
 	account_t *acc = set->data;
 	struct im_connection *ic = acc->ic;
-	struct msn_data *md;
-	char buf[1024], *fn;
-	
-	/* Double-check. */
+	
+	/* Allow any name if we're offline. */
 	if( ic == NULL )
-		return NULL;
-	
-	md = ic->proto_data;
+		return value;
 	
 	if( strlen( value ) > 129 )
@@ -301,15 +295,9 @@
 		return NULL;
 	}
-	
-	fn = msn_http_encode( value );
-	
-	g_snprintf( buf, sizeof( buf ), "REA %d %s %s\r\n", ++md->trId, ic->acc->user, fn );
-	msn_write( ic, buf, strlen( buf ) );
-	g_free( fn );
 	
 	/* Returning NULL would be better, because the server still has to
 	   confirm the name change. However, it looks a bit confusing to the
 	   user. */
-	return value;
+	return msn_set_display_name( ic, value ) ? value : NULL;
 }
 
Index: protocols/msn/msn.h
===================================================================
--- protocols/msn/msn.h	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ protocols/msn/msn.h	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -31,4 +31,5 @@
 #define TYPING_NOTIFICATION_MESSAGE "\r\r\rBEWARE, ME R TYPINK MESSAGE!!!!\r\r\r"
 #define GROUPCHAT_SWITCHBOARD_MESSAGE "\r\r\rME WANT TALK TO MANY PEOPLE\r\r\r"
+#define SB_KEEPALIVE_MESSAGE "\r\r\rDONT HANG UP ON ME!\r\r\r"
 
 #ifdef DEBUG_MSN
@@ -53,4 +54,8 @@
                            "TypingUser: %s\r\n" \
                            "\r\n\r\n"
+
+#define SB_KEEPALIVE_HEADERS "MIME-Version: 1.0\r\n" \
+                             "Content-Type: text/x-ping\r\n" \
+                             "\r\n\r\n"
 
 #define PROFILE_URL "http://members.msn.com/"
@@ -83,4 +88,5 @@
 	gint inp;
 	struct msn_handler_data *handler;
+	gint keepalive;
 	
 	int trId;
@@ -161,4 +167,5 @@
 char *msn_http_encode( const char *input );
 void msn_msgq_purge( struct im_connection *ic, GSList **list );
+gboolean msn_set_display_name( struct im_connection *ic, const char *rawname );
 
 /* tables.c */
@@ -179,4 +186,6 @@
 gboolean msn_sb_connected( gpointer data, gint source, b_input_condition cond );
 int msn_sb_write_msg( struct im_connection *ic, struct msn_message *m );
+void msn_sb_start_keepalives( struct msn_switchboard *sb, gboolean initial );
+void msn_sb_stop_keepalives( struct msn_switchboard *sb );
 
 #endif //_MSN_H
Index: protocols/msn/msn_util.c
===================================================================
--- protocols/msn/msn_util.c	(revision 5f8ab6a9adf09ea7c07f728227bdb6d3953588f1)
+++ protocols/msn/msn_util.c	(revision 814aa52228c7cad1d036c1a6dc5ea03cce61c048)
@@ -38,8 +38,8 @@
 		imcb_error( ic, "Short write() to main server" );
 		imc_logout( ic, TRUE );
-		return( 0 );
-	}
-	
-	return( 1 );
+		return 0;
+	}
+	
+	return 1;
 }
 
@@ -377,2 +377,14 @@
 	g_string_free( ret, TRUE );
 }
+
+gboolean msn_set_display_name( struct im_connection *ic, const char *rawname )
+{
+	char *fn = msn_http_encode( rawname );
+	struct msn_data *md = ic->proto_data;
+	char buf[1024];
+	
+	g_snprintf( buf, sizeof( buf ), "REA %d %s %s\r\n", ++md->trId, ic->acc->user, fn );
+	g_free( fn );
+	
+	return msn_write( ic, buf, strlen( buf ) ) != 0;
+}
